Poj3262【贪心】

/*Protecting the Flowers
Time Limit: 2000MS		Memory Limit: 65536K
Total Submissions: 4546		Accepted: 1820
Description

Farmer John went to cut some wood and left N (2 ≤ N ≤ 100,000) cows eating the grass, as usual. When he returned, he found to his horror
 that the cluster of cows was in his garden eating his beautiful flowers. Wanting to minimize the subsequent damage, FJ decided to take 
 immediate action and transport each cow back to its own barn.

Each cow i is at a location that is Ti minutes (1 ≤ Ti ≤ 2,000,000) away from its own barn. Furthermore, while waiting for transport, 
she destroys Di (1 ≤ Di ≤ 100) flowers per minute. No matter how hard he tries, FJ can only transport one cow at a time back to her barn.
 Moving cow i to its barn requires 2 × Ti minutes (Ti to get there and Ti to return). FJ starts at the flower patch, transports the cow to
  its barn, and then walks back to the flowers, taking no extra time to get to the next cow that needs transport.

Write a program to determine the order in which FJ should pick up the cows so that the total number of flowers destroyed is minimized.

Input

Line 1: A single integer N 
Lines 2..N+1: Each line contains two space-separated integers, Ti and Di, that describe a single cow's characteristics
Output

Line 1: A single integer that is the minimum number of destroyed flowers
Sample Input

6
3 1
2 5
2 3
3 2
4 1
1 6
Sample Output

86
Hint

FJ returns the cows in the following order: 6, 2, 3, 4, 1, 5. While he is transporting cow 6 to the barn, the others destroy 24 flowers;
 next he will take cow 2, losing 28 more of his beautiful flora. For the cows 3, 4, 1 he loses 16, 12, and 6 flowers respectively.
  When he picks cow 5 there are no more cows damaging the flowers, so the loss for that cow is zero. The total flowers lost this way 
  is 24 + 28 + 16 + 12 + 6 = 86.
Source

USACO 2007 January Silver*/
#include<stdio.h>
#include<stdlib.h>
struct cow
{
	__int64  t, d; 
} c[100010];
int cmp(const void*a, const void*b)
{
	return (*(struct cow*)a).t * (*(struct cow*)b).d - (*(struct cow*)b).t * (*(struct cow*)a).d;
} 
int main()
{
	__int64 T,i, j, n, m;
	scanf("%I64d", &T);
		n = 0;
		for(i = 0 ; i < T; i++)
		{
			scanf("%I64d%I64d", &c[i].t, &c[i].d);
			n += c[i].d;
		}
		qsort(c, T, sizeof(c[0]), cmp);//根据破坏力升序排列 
		m = 0; 
		for(i = 0; i < T; i++)
		{
			m += (__int64)2*c[i].t*(n-c[i].d);//计算损失 
			n -= c[i].d;
		} 
		printf("%I64d\n", m);
	return 0; 
} 

题意:有一群牛在花园里吃花,主人要把他们都牵回牛圈里,其中牵每头牛需要花费2t 时间,而每头牛每个单位时间会吃掉d朵花,现在给出一群牛的属性,求牵牛的顺序怎样能使花的损失最少。

思路:这道题先得考虑两头单独的牛和其他一群的牛,因为两头牛无论谁先谁后,牵走的时间对后面的牛来说都是一样的,在单独考虑牛1和牛2的时候,假设牛1先牵,那么造成的破坏力为2t1*d2,反过来则为2t2*d1,所以看哪头牛先被牵走所吃的花最少,则先牵哪头。所以整个序列就可以根据这个来排序,按顺序牵走破坏力小的牛,算出损失的花数。

体会:这道题的贪心排序有点难想,如果没想到将两头牛单独拉出来考虑的话。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值